<?php
/* -----------------------------------------------------------------------------------------
   M0005_xtcPrice.inc.php
   -----------------------------------------------------------------------------------------
   Released under the GNU General Public License 
   (c) 2013-2019 - Xycons GmbH & Co.KG - www.xycons.de - (M0005) (LC:06.04)
   -----------------------------------------------------------------------------------------
*/
class M0005_xtcPrice extends M0005_xtcPrice_parent 
{
    function xtcGetOptionPrice($p_products_id, $p_options_id, $p_options_values_id)
    {
        if(XYCONS_MOD0005_STATUS != 'true')
        {
            return parent::xtcGetOptionPrice($p_products_id, $p_options_id, $p_options_values_id);
        }        
        
        $t_option_data_array = array();

        $t_sql = "SELECT 
                                        pd.products_discount_allowed,
                                        pd.products_tax_class_id, 
                                        p.options_values_price, 
                                        p.price_prefix, 
                                        p.options_values_weight, 
                                        p.weight_prefix 
                                FROM 
                                        " . TABLE_PRODUCTS_ATTRIBUTES . " p, 
                                        " . TABLE_PRODUCTS . " pd 
                                WHERE
                                        p.products_id = '" . (int)$p_products_id . "' AND 
                                        p.options_id = '" . (int)$p_options_id . "' AND 
                                        pd.products_id = p.products_id AND 
                                        p.options_values_id = '" . (int)$p_options_values_id . "'";
        $t_result = xtc_db_query($t_sql);
        
        if(xtc_db_num_rows($t_result) > 0)
        {
                $t_result_array = xtc_db_fetch_array($t_result);
            
                // (M0005) (Start)
                $M0005 = Xycons_Protected::getInstance()->_initSingleModule('0005');
                $cPrice     = $M0005->GetCatDiscount($p_products_id);
                $cDiscount  = floatval($cPrice['discount']);                
                if($cDiscount > 0)
                {
                    $this->cStatus['customers_status_discount'] = $cDiscount;
                    $t_result_array['products_discount_allowed'] = $cDiscount;
                }                  
                // (swgx20005) (End)

                $t_discount = 0;

                if($this->cStatus['customers_status_discount_attributes'] == 1 && $this->cStatus['customers_status_discount'] != 0.00 && $this->xtcCheckSpecial($p_products_id) == false)
                {
                        $t_discount = $this->cStatus['customers_status_discount'];

                        if($t_result_array['products_discount_allowed'] < $this->cStatus['customers_status_discount'])
                        {
                                $t_discount = $t_result_array['products_discount_allowed'];
                        }
                }

                if($t_result_array['products_tax_class_id'] != 0)
                {
                        $t_price = $this->xtcFormat($t_result_array['options_values_price'], false, $t_result_array['products_tax_class_id']);
                }
                else
                {
                        $t_price = $this->xtcFormat($t_result_array['options_values_price'], false, $t_result_array['products_tax_class_id'], true);
                }

                if($t_result_array['weight_prefix'] != '+')
                {
                        $t_result_array['options_values_weight'] *= -1;
                }

                if($t_result_array['price_prefix'] == '+')
                {
                        $t_price = $t_price - $t_price / 100 * $t_discount;
                }
                else
                {
                        $t_price = ($t_price - $t_price / 100 * $t_discount) * -1;
                }

                $t_option_data_array['weight'] = $t_result_array['options_values_weight'];
                $t_option_data_array['price'] =  $t_price;
        }

        return $t_option_data_array;
    }
  
    function xtcCheckDiscount($p_products_id)
    {
        $discount_fix = 20;
        return $discount_fix;
        
        if(XYCONS_MOD0005_STATUS != 'true')
        {
            return parent::xtcCheckDiscount($p_products_id);
        }
        
        $db = StaticGXCoreLoader::getDatabaseQueryBuilder();
        $M0005 = Xycons_Protected::getInstance()->_initSingleModule('0005');     
        $cPrice     = $M0005->GetCatDiscount($p_products_id);
        $cDiscount  = floatval($cPrice['discount']);
        
        $pure_price = parent::getPprice($p_products_id);
        if($pure_price == 0 && $this->cStatus['customers_status_discount_attributes'] != 1)
        {
            $cDiscount = 0;
        }
        
        if($cDiscount > 0)
        {
            //$this->cStatus['customers_status_discount'] = $cDiscount;
            return $cDiscount;
        }        
        return parent::xtcCheckDiscount($p_products_id);
    }     
    
}